/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * UploadedResource
 */

public class UploadedResource {
  @JsonProperty("checksum")
  private Object checksum = null;

  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("extras")
  private Object extras = null;

  @JsonProperty("filesize")
  private Integer filesize = null;

  /**
   * Whether the resource is an uploaded file, a remote file or an API
   */
  public enum FiletypeEnum {
    FILE("file"),
    
    REMOTE("remote");

    private String value;

    FiletypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FiletypeEnum fromValue(String text) {
      for (FiletypeEnum b : FiletypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("filetype")
  private FiletypeEnum filetype = null;

  @JsonProperty("format")
  private String format = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("last_modified")
  private LocalDateTime lastModified = null;

  @JsonProperty("latest")
  private String latest = null;

  @JsonProperty("metrics")
  private Object metrics = null;

  @JsonProperty("mime")
  private String mime = null;

  @JsonProperty("preview_url")
  private String previewUrl = null;

  @JsonProperty("published")
  private LocalDateTime published = null;

  @JsonProperty("title")
  private String title = null;

  /**
   * Resource type (documentation, API...)
   */
  public enum TypeEnum {
    MAIN("main"),
    
    DOCUMENTATION("documentation"),
    
    UPDATE("update"),
    
    API("api"),
    
    CODE("code"),
    
    OTHER("other");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("url")
  private String url = null;

  @JsonProperty("success")
  private Boolean success = true;

  public UploadedResource checksum(Object checksum) {
    this.checksum = checksum;
    return this;
  }

   /**
   * A checksum to validate file validity
   * @return checksum
  **/
  @ApiModelProperty(value = "A checksum to validate file validity")
  public Object getChecksum() {
    return checksum;
  }

  public void setChecksum(Object checksum) {
    this.checksum = checksum;
  }

   /**
   * The resource creation date
   * @return createdAt
  **/
  @ApiModelProperty(value = "The resource creation date")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

  public UploadedResource description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The resource markdown description
   * @return description
  **/
  @ApiModelProperty(value = "The resource markdown description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public UploadedResource extras(Object extras) {
    this.extras = extras;
    return this;
  }

   /**
   * Extra attributes as key-value pairs
   * @return extras
  **/
  @ApiModelProperty(value = "Extra attributes as key-value pairs")
  public Object getExtras() {
    return extras;
  }

  public void setExtras(Object extras) {
    this.extras = extras;
  }

  public UploadedResource filesize(Integer filesize) {
    this.filesize = filesize;
    return this;
  }

   /**
   * The resource file size in bytes
   * @return filesize
  **/
  @ApiModelProperty(value = "The resource file size in bytes")
  public Integer getFilesize() {
    return filesize;
  }

  public void setFilesize(Integer filesize) {
    this.filesize = filesize;
  }

  public UploadedResource filetype(FiletypeEnum filetype) {
    this.filetype = filetype;
    return this;
  }

   /**
   * Whether the resource is an uploaded file, a remote file or an API
   * @return filetype
  **/
  @ApiModelProperty(example = "file", required = true, value = "Whether the resource is an uploaded file, a remote file or an API")
  public FiletypeEnum getFiletype() {
    return filetype;
  }

  public void setFiletype(FiletypeEnum filetype) {
    this.filetype = filetype;
  }

  public UploadedResource format(String format) {
    this.format = format;
    return this;
  }

   /**
   * The resource format
   * @return format
  **/
  @ApiModelProperty(required = true, value = "The resource format")
  public String getFormat() {
    return format;
  }

  public void setFormat(String format) {
    this.format = format;
  }

   /**
   * The resource unique ID
   * @return id
  **/
  @ApiModelProperty(value = "The resource unique ID")
  public String getId() {
    return id;
  }

   /**
   * The resource last modification date
   * @return lastModified
  **/
  @ApiModelProperty(value = "The resource last modification date")
  public LocalDateTime getLastModified() {
    return lastModified;
  }

   /**
   * The permanent URL redirecting to the latest version of the resource. When the resource data is updated, the URL will change, the latest URL won&#39;t.
   * @return latest
  **/
  @ApiModelProperty(value = "The permanent URL redirecting to the latest version of the resource. When the resource data is updated, the URL will change, the latest URL won't.")
  public String getLatest() {
    return latest;
  }

   /**
   * The resource metrics
   * @return metrics
  **/
  @ApiModelProperty(value = "The resource metrics")
  public Object getMetrics() {
    return metrics;
  }

  public UploadedResource mime(String mime) {
    this.mime = mime;
    return this;
  }

   /**
   * The resource mime type
   * @return mime
  **/
  @ApiModelProperty(value = "The resource mime type")
  public String getMime() {
    return mime;
  }

  public void setMime(String mime) {
    this.mime = mime;
  }

   /**
   * An optional preview URL to be loaded as a standalone page (ie. iframe or new page)
   * @return previewUrl
  **/
  @ApiModelProperty(value = "An optional preview URL to be loaded as a standalone page (ie. iframe or new page)")
  public String getPreviewUrl() {
    return previewUrl;
  }

  public UploadedResource published(LocalDateTime published) {
    this.published = published;
    return this;
  }

   /**
   * The resource publication date
   * @return published
  **/
  @ApiModelProperty(value = "The resource publication date")
  public LocalDateTime getPublished() {
    return published;
  }

  public void setPublished(LocalDateTime published) {
    this.published = published;
  }

  public UploadedResource title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The resource title
   * @return title
  **/
  @ApiModelProperty(required = true, value = "The resource title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public UploadedResource type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Resource type (documentation, API...)
   * @return type
  **/
  @ApiModelProperty(example = "main", required = true, value = "Resource type (documentation, API...)")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public UploadedResource url(String url) {
    this.url = url;
    return this;
  }

   /**
   * The resource URL
   * @return url
  **/
  @ApiModelProperty(required = true, value = "The resource URL")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

   /**
   * Whether the upload succeeded or not.
   * @return success
  **/
  @ApiModelProperty(value = "Whether the upload succeeded or not.")
  public Boolean isSuccess() {
    return success;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UploadedResource uploadedResource = (UploadedResource) o;
    return Objects.equals(this.checksum, uploadedResource.checksum) &&
        Objects.equals(this.createdAt, uploadedResource.createdAt) &&
        Objects.equals(this.description, uploadedResource.description) &&
        Objects.equals(this.extras, uploadedResource.extras) &&
        Objects.equals(this.filesize, uploadedResource.filesize) &&
        Objects.equals(this.filetype, uploadedResource.filetype) &&
        Objects.equals(this.format, uploadedResource.format) &&
        Objects.equals(this.id, uploadedResource.id) &&
        Objects.equals(this.lastModified, uploadedResource.lastModified) &&
        Objects.equals(this.latest, uploadedResource.latest) &&
        Objects.equals(this.metrics, uploadedResource.metrics) &&
        Objects.equals(this.mime, uploadedResource.mime) &&
        Objects.equals(this.previewUrl, uploadedResource.previewUrl) &&
        Objects.equals(this.published, uploadedResource.published) &&
        Objects.equals(this.title, uploadedResource.title) &&
        Objects.equals(this.type, uploadedResource.type) &&
        Objects.equals(this.url, uploadedResource.url) &&
        Objects.equals(this.success, uploadedResource.success);
  }

  @Override
  public int hashCode() {
    return Objects.hash(checksum, createdAt, description, extras, filesize, filetype, format, id, lastModified, latest, metrics, mime, previewUrl, published, title, type, url, success);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UploadedResource {\n");

    sb.append("    checksum: ").append(toIndentedString(checksum)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    extras: ").append(toIndentedString(extras)).append("\n");
    sb.append("    filesize: ").append(toIndentedString(filesize)).append("\n");
    sb.append("    filetype: ").append(toIndentedString(filetype)).append("\n");
    sb.append("    format: ").append(toIndentedString(format)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("    latest: ").append(toIndentedString(latest)).append("\n");
    sb.append("    metrics: ").append(toIndentedString(metrics)).append("\n");
    sb.append("    mime: ").append(toIndentedString(mime)).append("\n");
    sb.append("    previewUrl: ").append(toIndentedString(previewUrl)).append("\n");
    sb.append("    published: ").append(toIndentedString(published)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

